﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using Ivi.Visa.Interop;
//'' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""
//''  © Agilent Technologies, Inc. 2013
//''
//'' You have a royalty-free right to use, modify, reproduce and distribute
//'' the Sample Application Files (and/or any modified version) in any way
//'' you find useful, provided that you agree that Agilent Technologies has no
//'' warranty,  obligations or liability for any Sample Application Files.
//''
//'' Agilent Technologies provides programming examples for illustration only,
//'' This sample program assumes that you are familiar with the programming
//'' language being demonstrated and the tools used to create and debug
//'' procedures. Agilent Technologies support engineers can help explain the
//'' functionality of Agilent Technologies software components and associated
//'' commands, but they will not modify these samples to provide added
//'' functionality or construct procedures to meet your specific needs.
//'' """""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""""


namespace CsharpExample
{
    class FunctionsExample
    {

        static void Main(string[] args)
        {
               /*'This example program illustrates how to connect to an instrument
        'Gives an example setup for all major function configurations (DCV, DCI, Ohms2W, Ohms 4W, ACV, ACI, Temp, Freq). 
        'Gets a single reading from the DMM for each function and reports the result. 
        'Ohms 4W shows an autorange setup while all other functions show a direct range setup.
                * */


            FunctionsExample DmmClass = new FunctionsExample(); //Create an instance of this class so we can call functions from Main
                //For more information on getting started using VISA COM I/O operations see the app note located at:
                //http://cp.literature.agilent.com/litweb/pdf/5989-6338EN.pdf

                Ivi.Visa.Interop.ResourceManager rm = new Ivi.Visa.Interop.ResourceManager(); //Open up a new resource manager
                Ivi.Visa.Interop.FormattedIO488 myDmm = new Ivi.Visa.Interop.FormattedIO488(); //Open a new Formatted IO 488 session 
            try
            {
                //string DutAddr = "GPIB0::22"; //String for GPIB
                //string DutAddr = ""TCPIP0::169.254.4.61";  //Example string for LAN
                //string DutAddr = "USB0::0x0957::0x1A07::MY53000101"; //Example string for USB
                string DutAddr = "USB0::0x0957::0x1C07::US00000069::0::INSTR"; //String for GPIB

                myDmm.IO = (IMessage)rm.Open(DutAddr, AccessMode.NO_LOCK, 2000, ""); //Open up a handle to the DMM with a 2 second timeout
                myDmm.IO.Timeout = 3000; //You can also set your timeout by doing this command, sets to 3 seconds
                
                //First start off with a reset state
                myDmm.IO.Clear(); //Send a device clear first to stop any measurements in process
                myDmm.WriteString("*RST", true); //Reset the device
                myDmm.WriteString("*IDN?", true); //Get the IDN string                
                string IDN = myDmm.ReadString();
                Console.WriteLine(IDN); //report the DMM's identity
                
                //Configure for DCV 100V range, 100uV resolution
                myDmm.WriteString("CONF:VOLT:DC 100, 0.0001", true);
                myDmm.WriteString("READ?", true);
                string DCVResult = myDmm.ReadString();
                Console.WriteLine("DCV Reading = " + DCVResult); //report the DCV reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for ACV 100V range, to read a 100 Hz signal
                myDmm.WriteString("CONF:VOLT:AC 100, 0.0001", true);
                myDmm.WriteString("VOLT:AC:BAND 20", true);//Choose the band that is lower than your input frequency, Bands are 3 Hz|20 Hz|200 Hz
                myDmm.WriteString("READ?", true);
                string ACVResult = myDmm.ReadString();
                Console.WriteLine("ACV Reading = " + ACVResult); //report the ACV reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for DCI 10A range, 100uA resolution
                myDmm.WriteString("CONF:CURR:DC 10, 0.0001", true);
                myDmm.WriteString("READ?", true);
                string DCIResult = myDmm.ReadString();
                Console.WriteLine("DCI Reading = " + DCIResult); //report the DCI reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for ACI 10mA range, to read a 100 KHz signal
                myDmm.WriteString("CONF:CURR:AC .01, 0.0001", true);
                myDmm.WriteString("VOLT:AC:BAND 200", true);//Choose the band that is lower than your input frequency, Bands are 3 Hz|20 Hz|200 Hz
                myDmm.WriteString("READ?", true);
                string ACIResult = myDmm.ReadString();
                Console.WriteLine("ACI Reading = " + ACIResult); //report the ACV reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for OHM 2 wire 100 Ohm range, 100uOhm resolution
                myDmm.WriteString("CONF:RES 100, 0.0001", true);
                myDmm.WriteString("READ?", true);
                string Res2WResult = myDmm.ReadString();
                Console.WriteLine("2 Wire Resistance Reading = " + Res2WResult); //report the 2W resistance reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for OHM 4 wire Autoranged
                myDmm.WriteString("CONF:FRES", true);
                myDmm.WriteString("READ?", true);
                string Res4WResult = myDmm.ReadString();
                Console.WriteLine("4 Wire Resistance Reading = " + Res4WResult); //report the 4W resistance reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                
                //Configure for Frequency 100V, 1Khz signal, maximum resolution
                myDmm.WriteString("CONF:FREQ 200, MAX", true); //Sets the bandwidth range to 200 (highest BW range) which will measure a 1Khz signal
                myDmm.WriteString("FREQ:VOLT:RANG  100", true);
                myDmm.WriteString("READ?", true);
                string FreqResult = myDmm.ReadString();
                Console.WriteLine("Freq Reading = " + FreqResult); //report the Freq reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                //Configure for Temperature reading with a 5K thermistor
                myDmm.WriteString("CONF:Temp THER, 5000", true);
                myDmm.WriteString("READ?", true);
                string TempResult = myDmm.ReadString();
                Console.WriteLine("Temperature Reading = " + TempResult); //report the Temperature reading
                DmmClass.CheckDMMError(myDmm); //Check if the DMM has any errors

                
            }
            catch (Exception e)
            {
                Console.WriteLine("Error occured: " + e.Message);
            }
            finally
            {
                //Close out your resources
                try { myDmm.IO.Close(); }
                catch{}
                try{ System.Runtime.InteropServices.Marshal.ReleaseComObject(myDmm);}
                catch {}
                try{
                System.Runtime.InteropServices.Marshal.ReleaseComObject(rm);
                }
                catch {}
                Console.WriteLine("Press any key to continue...");
                Console.ReadKey();

            }

        }
        public void CheckDMMError(FormattedIO488 myDmm)
        {

            myDmm.WriteString("SYST:ERR?", true);
            string errStr = myDmm.ReadString();
            
            if (errStr.Contains("No error")) //If no error, then return
                return;
            //If there is an error, read out all of the errors and return them in an exception
            else
            {
                string errStr2 = "";                
                do
                {
                    myDmm.WriteString("SYST:ERR?", true);
                    errStr2 = myDmm.ReadString();
                    if (!errStr2.Contains("No error")) errStr = errStr + "\n" + errStr2;

                } while (!errStr2.Contains("No error"));                
                throw new Exception("Exception: Encountered system error(s)\n" + errStr);
            }

        }
    }
}
